# "Do not Blink !" by ᴏʀɪᴏɴ™
<b>This mod aims to <i>somewhat</i> mimic the blink mechanic of SCP: Containment Breach.</b> It is obviously not 100% accurate.

## INFORMATION
So, all this mod does is simulate the act of blinking. Mind you, it doesn't serve much purpose, unless you are near a Coil-Head that is...

Basically, you will randomly, and periodically blink for a really short amount of time.<br>
Both the interval and duration of a blink are randomly chosen between two values (min & max).<br>
They also scale based on your insanity level kindly provided by the game.<br>
The more insane you are, the more you will blink.

The interval at which you blink is directly displayed right under your sprint meter as a horizontal progress meter enterily made of ```[```, ```▓```, ```░``` and ```]```.<br>
![BlinkMeter](https://s13.gifyu.com/images/Sj6NG.gif)

The meter continuously drains down until you blink, and refills right after. Remember, each blink interval is different, so the meter will never drain at the same speed.<br>
If you need to refill your blink-meter, press **C** on your keyboard to manually blink and set your next blink to a fixed 14s (default). This will start a new blink cycle.<br>
Last bit of info, you can keep your eyes closed (surely a Bracken won't kill you...), and while you do, your insanity will slowly decrease, which in turn makes blinking less frequent.

## CONFIGURATION
• Almost all values are editable in the .cfg inside config folder created by BepInEx insde ```.\Lethal Company\BepInEx```. The file should be named ```Orion.DontBlink.cfg```.<br>
• If you do not want any random factor in blink duration/interval, simply use the same value on both 'min' and 'max'.<br>
• Side note, as of the latest version (1.1.0), all blink related values were modified to be as close as possible to SCP:CB values (the random aspect was kept), you may need to either delete the .cfg file or edit it manually if you had a previous version. Leave it be if you want to keep old values.

## COMPATIBILITY
### [InsanityRemastered](https://thunderstore.io/c/lethal-company/p/BudgetAirpods/InsanityRemastered/)
There shouldn't be any conflict.

## OPTIONAL FEATURES
All optional features are disabled by default, but you are free to enable them if you wish.
### • GAS LEAK RAPID METER DRAIN:
- **while you are inside a gas/steam leak, your blink meter will rapidly drain.**<br>
  - Multiply the meter drain by 4 (default).
  - Uses the same logic as the 'VISIBILITY LOW' warning, so it may not trigger on some case.
### • NATURAL BLINK ONLY ACTIVE AFTER SEEING A COIL-HEAD.:
- **natural blink is disabled and the hud meter is hidden, but when you see a coil-head, they will appear and function normally.**<br>
  - The natural blink and hud last for 5 seconds (default).
  - The Ghost Girl can also trigger it.
### • BLINK ON FEAR:
- **whenever you'd gain a sudden surge of fear based on certain events, you will blink.**<br>
  - Some of these events are : Thumper's screech, seeing the Bracken, being too close to a creature, getting hit, seeing a body, etc.
  - This feature has 3 states (has to be edited inside the .cfg):
    - **0 = Disabled (default).**
    - 1 = Randomly blink based on the 'fear event' potency. Stronger fear = higher chances of blinking.
    - 2 = Always blink when feared (not recommended).
  - There is an internal cooldown of 1s (default). I strongly recommend to NOT go below 0,5s.
  - This feature *should* be compatible with InsanityRemastered. Do note it is **NOT** hooked to IR's hallucinations events etc.

## INSTALLATION (MANUAL)
<details>
<summary><b>NOT YET MODDED (no BepInEx)</b> <sup><sub>(click to open)</sub></sup></summary>

1. Download **BepInEx 5.4.21** from either its [Thunderstore page](https://thunderstore.io/c/lethal-company/p/BepInEx/BepInExPack/) or its [official GitHub](https://github.com/BepInEx/BepInEx/releases/tag/v5.4.21). Latest version <i>should</i> be fine too.
<br>Inside the downloaded .zip, extract the ```BepInEx``` folder and both ```winhttp.dll``` and ```doorstop_config.ini``` inside your game folder (where the game .exe is located).
<br><sup><sub>If downloaded through Thunderstore, they are stored inside the ```BepInExPack``` folder.</sub></sup>
2. Run the game once to generate all folders and files, then exit the game when the game menu appears.
3. You are now done with BepInEx !
</details>

1. Download **DontBlink** and extract ```DontBlink.dll``` from inside the .zip to ```.\Lethal Company\BepInEx\plugins```.
2. You are done ! Enjoy !

## PLANS
• Make the player react to more events.<br>
• Make the blink meter an actual graphic component.<br>
Whenever I add new features, they will all be added as optional and disabled by default.

## RAMBLING / DISCLAIMER
Why ? I wanted a blink mechanic to see how it would fit in game, so I first looked into the store, but all I could find was [Blink](https://thunderstore.io/c/lethal-company/p/Shadowoof/Blink/) by [Shadowoof](https://thunderstore.io/c/lethal-company/p/Shadowoof/), which didn't seem to work at the time, as least not for me.<br>
So, I pretty much made this on a whim. I am a newborn baby to Unity's modding (I do have some prog knowledge, but that's about it) so don't expect too much, but I do hope this'll be enough for you.

## CREDITS
• [Zeekerss](https://twitter.com/ZeekerssRBLX), creator of Lethal Company.<br>
• [BepInEx's team](https://github.com/BepInEx/BepInEx), creator of BepInEx, making Unity's modding possible.<br>
• [MrMiinxx](https://www.youtube.com/@mrmiinxx1877), who made [this video tutorial](https://www.youtube.com/watch?v=4Q7Zp5K2ywI), which I used to make the barebones of the mod.<br>
• [matsuura](...), who made [HealthMetrics](https://thunderstore.io/c/lethal-company/p/matsuura/HealthMetrics/), which I used part of his HUDManagerPatch to create the HUD part.<br>
• And last, but not least, Coil-Head, such a cool dude.

## DISCORD
**[Unofficial Lethal Company Community](https://discord.gg/nYcQFEpXfU)**<br>
I have made a post to track bugs and share updates : [DontBlink on ULCC](https://discord.com/channels/1169792572382773318/1190126266377052253/1190126266377052253)

<sub>*Excuse my poor english.*</sub>